<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Mesh Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_mesh.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_mesh-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Mesh Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate triangular meshes.  
 <a href="class_mesh.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_mesh_8hpp_source.html">Mesh.hpp</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Mesh:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_mesh.png" usemap="#Mesh_map" alt=""/>
  <map id="Mesh_map" name="Mesh_map">
<area href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). " alt="Surface" shape="rect" coords="0,0,57,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:afca381025e36aeaf6dcab4f8aa89113c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c">transform</a> ()</td></tr>
<tr class="memdesc:afca381025e36aeaf6dcab4f8aa89113c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the application of all transforms defined for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects with <a class="el" href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975" title="Associates a Transform node to this Mesh. The method transform() can then be used to change the Mesh&#39;...">setTransform()</a>  <a href="#afca381025e36aeaf6dcab4f8aa89113c">More...</a><br /></td></tr>
<tr class="separator:afca381025e36aeaf6dcab4f8aa89113c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3600172f6279d1d50bbecf3abbb7b0bd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#a3600172f6279d1d50bbecf3abbb7b0bd">normals_at_vertexes</a> ()</td></tr>
<tr class="memdesc:a3600172f6279d1d50bbecf3abbb7b0bd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Triggers the computation of the normal vectors for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects stored in the Vector surfaces.  <a href="#a3600172f6279d1d50bbecf3abbb7b0bd">More...</a><br /></td></tr>
<tr class="separator:a3600172f6279d1d50bbecf3abbb7b0bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a580c671b9f4f22257a82c5ac252e311c"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#a580c671b9f4f22257a82c5ac252e311c">Mesh</a> (const char *filename, <a class="el" href="class_material.html">Material</a> *_m, bool _smooth_shading)</td></tr>
<tr class="memdesc:a580c671b9f4f22257a82c5ac252e311c"><td class="mdescLeft">&#160;</td><td class="mdescRight">A constructor to build a <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> from an .obj file.  <a href="#a580c671b9f4f22257a82c5ac252e311c">More...</a><br /></td></tr>
<tr class="separator:a580c671b9f4f22257a82c5ac252e311c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2598c2ab155e0ad3182798a5c8efbc0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#ae2598c2ab155e0ad3182798a5c8efbc0">Mesh</a> (std::string _id, const char *filename, <a class="el" href="class_material.html">Material</a> *<a class="el" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a>, bool _smooth_shading)</td></tr>
<tr class="memdesc:ae2598c2ab155e0ad3182798a5c8efbc0"><td class="mdescLeft">&#160;</td><td class="mdescRight">A constructor to build a <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> from an .obj file.  <a href="#ae2598c2ab155e0ad3182798a5c8efbc0">More...</a><br /></td></tr>
<tr class="separator:ae2598c2ab155e0ad3182798a5c8efbc0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a5773b7b3f1457e0e1667a8b5c49975"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975">setTransform</a> (<a class="el" href="class_transform.html">Transform</a> *_tf)</td></tr>
<tr class="memdesc:a3a5773b7b3f1457e0e1667a8b5c49975"><td class="mdescLeft">&#160;</td><td class="mdescRight">Associates a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. The method <a class="el" href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c" title="Triggers the application of all transforms defined for all Surface and Light objects with setTransfor...">transform()</a> can then be used to change the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>'s pose/scale based on _tf.  <a href="#a3a5773b7b3f1457e0e1667a8b5c49975">More...</a><br /></td></tr>
<tr class="separator:a3a5773b7b3f1457e0e1667a8b5c49975"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a216201cebabdd7341983615e19239c94"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#a216201cebabdd7341983615e19239c94">setMaterial</a> (<a class="el" href="class_material.html">Material</a> *_m)</td></tr>
<tr class="memdesc:a216201cebabdd7341983615e19239c94"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the material for this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>.  <a href="#a216201cebabdd7341983615e19239c94">More...</a><br /></td></tr>
<tr class="separator:a216201cebabdd7341983615e19239c94"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa6d51dcd0b3636a992b509621afef87"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#afa6d51dcd0b3636a992b509621afef87">addSurfaces</a> (std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;objects)</td></tr>
<tr class="memdesc:afa6d51dcd0b3636a992b509621afef87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds all triangles (their pointers, actually) belonging to this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> to a given vector of surfaces.  <a href="#afa6d51dcd0b3636a992b509621afef87">More...</a><br /></td></tr>
<tr class="separator:afa6d51dcd0b3636a992b509621afef87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb73d5cb7028e1138cb714b34d01bbca"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#abb73d5cb7028e1138cb714b34d01bbca">hit</a> (const <a class="el" href="class_ray.html">Ray</a> &amp;r, <a class="el" href="structhit__rec.html">hit_rec</a> &amp;h_r, double t_min, double t_max)</td></tr>
<tr class="separator:abb73d5cb7028e1138cb714b34d01bbca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0560f1ba7ad6b24a176ab302723b0fa2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#a0560f1ba7ad6b24a176ab302723b0fa2">bounding_box</a> ()</td></tr>
<tr class="memdesc:a0560f1ba7ad6b24a176ab302723b0fa2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the bounding box of this mesh.  <a href="#a0560f1ba7ad6b24a176ab302723b0fa2">More...</a><br /></td></tr>
<tr class="separator:a0560f1ba7ad6b24a176ab302723b0fa2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc5d10d24bcc8b127ce9033cf01cb73b"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_box.html">Box</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#acc5d10d24bcc8b127ce9033cf01cb73b">getBBox</a> ()</td></tr>
<tr class="memdesc:acc5d10d24bcc8b127ce9033cf01cb73b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the bounding box of this mesh.  <a href="#acc5d10d24bcc8b127ce9033cf01cb73b">More...</a><br /></td></tr>
<tr class="separator:acc5d10d24bcc8b127ce9033cf01cb73b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed5f345616e0d840eb59e1f4a0c77df9"><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#aed5f345616e0d840eb59e1f4a0c77df9">getCentroid</a> ()</td></tr>
<tr class="memdesc:aed5f345616e0d840eb59e1f4a0c77df9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the centroid of this mesh.  <a href="#aed5f345616e0d840eb59e1f4a0c77df9">More...</a><br /></td></tr>
<tr class="separator:aed5f345616e0d840eb59e1f4a0c77df9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_class_surface')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">Surface</a> (<a class="el" href="class_material.html">Material</a> *&amp;_m)</td></tr>
<tr class="memdesc:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> constructor. This is not supposed to be called directly by the user.  <a href="class_surface.html#a66c78e81a329eee37ddad0dece149b96">More...</a><br /></td></tr>
<tr class="separator:a66c78e81a329eee37ddad0dece149b96 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fc57f2a15292135c00545c9d224ec68 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a8fc57f2a15292135c00545c9d224ec68">Surface</a> ()</td></tr>
<tr class="separator:a8fc57f2a15292135c00545c9d224ec68 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89de75c95cb550d432f3ea4ed1429db0 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a89de75c95cb550d432f3ea4ed1429db0">~Surface</a> ()</td></tr>
<tr class="separator:a89de75c95cb550d432f3ea4ed1429db0 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">setID</a> (std::string _id)</td></tr>
<tr class="memdesc:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a unique identifier for this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="class_surface.html#ab59cc271b2fe0db25867fc16664cc22f">More...</a><br /></td></tr>
<tr class="separator:ab59cc271b2fe0db25867fc16664cc22f inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">isSmoothShaded</a> ()</td></tr>
<tr class="memdesc:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a boolean stating whether this surface should be renderered with smooth shading.  <a href="class_surface.html#ab13775c761a7b51a95b57d300b94a9c8">More...</a><br /></td></tr>
<tr class="separator:ab13775c761a7b51a95b57d300b94a9c8 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">setSmoothShading</a> (bool _smooth_shading)</td></tr>
<tr class="memdesc:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets a boolean stating whether this surface should be renderered with smooth shading.  <a href="class_surface.html#ae844c2766ec89af9dd6e65db59cf0b02">More...</a><br /></td></tr>
<tr class="separator:ae844c2766ec89af9dd6e65db59cf0b02 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">getVertexPosLocalCoords</a> (int _i)</td></tr>
<tr class="memdesc:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="class_surface.html#ab04a7e3f5f5b51061b014bdbcfd85107">More...</a><br /></td></tr>
<tr class="separator:ab04a7e3f5f5b51061b014bdbcfd85107 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">getVertexPosWorldCoords</a> (int _i)</td></tr>
<tr class="memdesc:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the position of the i-th vertex in the world frame (after being affected by the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> hierarchy).  <a href="class_surface.html#a80450b9cb334e067ddaacb4380149c8e">More...</a><br /></td></tr>
<tr class="separator:a80450b9cb334e067ddaacb4380149c8e inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">setVertexPosLocalCoords</a> (int _i, <a class="el" href="class_vec.html">Vec</a> _pos)</td></tr>
<tr class="memdesc:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the position of the i-th vertex in the object frame (without being affected by any <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a>).  <a href="class_surface.html#a7a455dca43c650016886ea02320ed4a3">More...</a><br /></td></tr>
<tr class="separator:a7a455dca43c650016886ea02320ed4a3 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">getMaterial</a> ()</td></tr>
<tr class="memdesc:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>.  <a href="class_surface.html#a1ffcbcea002fc72862411a3edbd386a7">More...</a><br /></td></tr>
<tr class="separator:a1ffcbcea002fc72862411a3edbd386a7 inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">getTransform</a> ()</td></tr>
<tr class="memdesc:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node associated with this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> through method setTransform.  <a href="class_surface.html#a25a12923766c3df006fa32628fe6bd4b">More...</a><br /></td></tr>
<tr class="separator:a25a12923766c3df006fa32628fe6bd4b inherit pub_methods_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:acbef3f84de109c5f89ee4aa377a3657c"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#acbef3f84de109c5f89ee4aa377a3657c">surfaces</a></td></tr>
<tr class="memdesc:acbef3f84de109c5f89ee4aa377a3657c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector of pointers to the <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects that compose this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>.  <a href="#acbef3f84de109c5f89ee4aa377a3657c">More...</a><br /></td></tr>
<tr class="separator:acbef3f84de109c5f89ee4aa377a3657c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0f87ac2cccc51a28e2e296c1e665609"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::vector&lt; <a class="el" href="class_surface.html">Surface</a> * &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mesh.html#ab0f87ac2cccc51a28e2e296c1e665609">verts</a></td></tr>
<tr class="separator:ab0f87ac2cccc51a28e2e296c1e665609"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_attribs_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pub_attribs_class_surface')"><img src="closed.png" alt="-"/>&#160;Public Attributes inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_vertex.html">Vertex</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">vertexes</a></td></tr>
<tr class="memdesc:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vector of vertexes associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Derived classes must use this vector if bounding boxes and transforms are to be applied.  <a href="class_surface.html#ac8918f57a731e9f129c4a2051d0bc15d">More...</a><br /></td></tr>
<tr class="separator:ac8918f57a731e9f129c4a2051d0bc15d inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a60490e6d2fe723957e8814289f538624">id</a></td></tr>
<tr class="memdesc:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">A string containing a unique ID for the surface.  <a href="class_surface.html#a60490e6d2fe723957e8814289f538624">More...</a><br /></td></tr>
<tr class="separator:a60490e6d2fe723957e8814289f538624 inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a65d1534766e141346af770b5e95503bf">b_box_def</a></td></tr>
<tr class="memdesc:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if a bounding box has been defined already.  <a href="class_surface.html#a65d1534766e141346af770b5e95503bf">More...</a><br /></td></tr>
<tr class="separator:a65d1534766e141346af770b5e95503bf inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_material.html">Material</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">m</a></td></tr>
<tr class="memdesc:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this surface.  <a href="class_surface.html#a99bb89c6eeea7dd90b3fda098b51422b">More...</a><br /></td></tr>
<tr class="separator:a99bb89c6eeea7dd90b3fda098b51422b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">smooth_shading</a></td></tr>
<tr class="memdesc:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Flag stating if Phong interpolation is to be used.  <a href="class_surface.html#aa7675dc7633490a99cd39620054e2bdb">More...</a><br /></td></tr>
<tr class="separator:aa7675dc7633490a99cd39620054e2bdb inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">local_n</a></td></tr>
<tr class="memdesc:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the local frame of reference (computed elsewhere)  <a href="class_surface.html#ad3cebceee209a3762a5dc2550d69064c">More...</a><br /></td></tr>
<tr class="separator:ad3cebceee209a3762a5dc2550d69064c inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">n</a></td></tr>
<tr class="memdesc:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight"><a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>'s associated normal in the global frame of reference - updated with <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b" title="Triggers the application of the transform provided with setTransform() to all Vertex objects associat...">transform()</a>  <a href="class_surface.html#a7df9cc390062b02fa30e18eaea47dc3b">More...</a><br /></td></tr>
<tr class="separator:a7df9cc390062b02fa30e18eaea47dc3b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_box.html">Box</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a676d836b2651caf205065fcd095a356b">b_box</a></td></tr>
<tr class="memdesc:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Bounding box (a <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> itself - currently a <a class="el" href="class_box.html">Box</a>) encompassing all vertexes of this surface.  <a href="class_surface.html#a676d836b2651caf205065fcd095a356b">More...</a><br /></td></tr>
<tr class="separator:a676d836b2651caf205065fcd095a356b inherit pub_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_class_surface"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_class_surface')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="class_surface.html">Surface</a></td></tr>
<tr class="memitem:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_transform.html">Transform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_surface.html#a444077659d77f2e034ae163cbb103134">tf</a></td></tr>
<tr class="memdesc:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> object associated to this <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a>. Set this variable with setTransform.  <a href="class_surface.html#a444077659d77f2e034ae163cbb103134">More...</a><br /></td></tr>
<tr class="separator:a444077659d77f2e034ae163cbb103134 inherit pro_attribs_class_surface"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate triangular meshes. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a580c671b9f4f22257a82c5ac252e311c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a580c671b9f4f22257a82c5ac252e311c">&sect;&nbsp;</a></span>Mesh() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Mesh::Mesh </td>
          <td>(</td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>_m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_smooth_shading</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A constructor to build a <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> from an .obj file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filename</td><td>Path to the .obj file </td></tr>
    <tr><td class="paramname">m</td><td>Pointer to object <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> to be applied to the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> </td></tr>
    <tr><td class="paramname">_smooth_shading</td><td>Flag stating if the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> is to be rendered with Phong interpolation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae2598c2ab155e0ad3182798a5c8efbc0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2598c2ab155e0ad3182798a5c8efbc0">&sect;&nbsp;</a></span>Mesh() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">Mesh::Mesh </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>_id</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>m</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>_smooth_shading</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A constructor to build a <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> from an .obj file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_id</td><td>A string containing the ID of the mesh </td></tr>
    <tr><td class="paramname">filename</td><td>Path to the .obj file </td></tr>
    <tr><td class="paramname">m</td><td>Pointer to object <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> to be applied to the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> </td></tr>
    <tr><td class="paramname">_smooth_shading</td><td>Flag stating if the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> is to be rendered with Phong interpolation </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="afa6d51dcd0b3636a992b509621afef87"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afa6d51dcd0b3636a992b509621afef87">&sect;&nbsp;</a></span>addSurfaces()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::addSurfaces </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="class_surface.html">Surface</a> *&gt; &amp;&#160;</td>
          <td class="paramname"><em>objects</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds all triangles (their pointers, actually) belonging to this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a> to a given vector of surfaces. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">objects</td><td>The vector of surfaces that will receive all triangles contained in this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="class_surface.html#a6eaec7d61d4a87ce7cd42089487850bf">Surface</a>.</p>

</div>
</div>
<a id="a0560f1ba7ad6b24a176ab302723b0fa2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0560f1ba7ad6b24a176ab302723b0fa2">&sect;&nbsp;</a></span>bounding_box()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::bounding_box </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Computes the bounding box of this mesh. </p>

<p>Reimplemented from <a class="el" href="class_surface.html#a1dabf409cbd72a6cf1984a21304369ff">Surface</a>.</p>

</div>
</div>
<a id="acc5d10d24bcc8b127ce9033cf01cb73b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acc5d10d24bcc8b127ce9033cf01cb73b">&sect;&nbsp;</a></span>getBBox()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_box.html">Box</a> Mesh::getBBox </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the bounding box of this mesh. </p>
<dl class="section return"><dt>Returns</dt><dd>The bounding box of this triangle. </dd></dl>

<p>Reimplemented from <a class="el" href="class_surface.html#ae3cf222676c208dc301ffc1dacb028e1">Surface</a>.</p>

</div>
</div>
<a id="aed5f345616e0d840eb59e1f4a0c77df9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aed5f345616e0d840eb59e1f4a0c77df9">&sect;&nbsp;</a></span>getCentroid()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Mesh::getCentroid </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns the centroid of this mesh. </p>
<dl class="section return"><dt>Returns</dt><dd>The centroid of this triangle. </dd></dl>

<p>Reimplemented from <a class="el" href="class_surface.html#a1b0c1c392cc14642a7ff88db7c16d0f0">Surface</a>.</p>

</div>
</div>
<a id="abb73d5cb7028e1138cb714b34d01bbca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abb73d5cb7028e1138cb714b34d01bbca">&sect;&nbsp;</a></span>hit()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool Mesh::hit </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_ray.html">Ray</a> &amp;&#160;</td>
          <td class="paramname"><em>r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structhit__rec.html">hit_rec</a> &amp;&#160;</td>
          <td class="paramname"><em>h_r</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>t_max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Triggers the intersection tests over all geometry contained in this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>, given a <a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a>. Each <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> is responsible for its own intersection test.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">r</td><td><a class="el" href="class_ray.html" title="A class to create and manipulate 3D rays. ">Ray</a> to be tested </td></tr>
    <tr><td class="paramname">h_r</td><td>hit record that stores the information regarding the first intersection between r and the mesh's geometry </td></tr>
    <tr><td class="paramname">t_min</td><td>controls the closest allowed intersection </td></tr>
    <tr><td class="paramname">t_max</td><td>controls the furthest allowed intersection </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="class_surface.html#ad5b74adad1504d73dbed6e47bc011bca">Surface</a>.</p>

</div>
</div>
<a id="a3600172f6279d1d50bbecf3abbb7b0bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3600172f6279d1d50bbecf3abbb7b0bd">&sect;&nbsp;</a></span>normals_at_vertexes()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::normals_at_vertexes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Triggers the computation of the normal vectors for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects stored in the Vector surfaces. </p>

</div>
</div>
<a id="a216201cebabdd7341983615e19239c94"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a216201cebabdd7341983615e19239c94">&sect;&nbsp;</a></span>setMaterial()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::setMaterial </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>_m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the material for this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_m</td><td>A pointer to the <a class="el" href="class_material.html" title="A class to create and manipulate surface materials. ">Material</a> associated to this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="class_surface.html#a2110a2eb3f0279d59a52e2034069eaae">Surface</a>.</p>

</div>
</div>
<a id="a3a5773b7b3f1457e0e1667a8b5c49975"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3a5773b7b3f1457e0e1667a8b5c49975">&sect;&nbsp;</a></span>setTransform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::setTransform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_transform.html">Transform</a> *&#160;</td>
          <td class="paramname"><em>_tf</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Associates a <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node to this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. The method <a class="el" href="class_mesh.html#afca381025e36aeaf6dcab4f8aa89113c" title="Triggers the application of all transforms defined for all Surface and Light objects with setTransfor...">transform()</a> can then be used to change the <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>'s pose/scale based on _tf. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tf</td><td>pointer to the <a class="el" href="class_transform.html" title="A class to handle rigid transformations. ">Transform</a> node </td></tr>
  </table>
  </dd>
</dl>

<p>Reimplemented from <a class="el" href="class_surface.html#abcbeb2a388e4971bd7095ce57e85fb95">Surface</a>.</p>

</div>
</div>
<a id="afca381025e36aeaf6dcab4f8aa89113c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afca381025e36aeaf6dcab4f8aa89113c">&sect;&nbsp;</a></span>transform()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void Mesh::transform </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Triggers the application of all transforms defined for all <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> and <a class="el" href="class_light.html" title="A class to create and manipulate light sources. ">Light</a> objects with <a class="el" href="class_mesh.html#a3a5773b7b3f1457e0e1667a8b5c49975" title="Associates a Transform node to this Mesh. The method transform() can then be used to change the Mesh&#39;...">setTransform()</a> </p>

<p>Reimplemented from <a class="el" href="class_surface.html#a10655735b685f4363df818a2c6fdfb9b">Surface</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="acbef3f84de109c5f89ee4aa377a3657c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acbef3f84de109c5f89ee4aa377a3657c">&sect;&nbsp;</a></span>surfaces</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="class_surface.html">Surface</a>*&gt; Mesh::surfaces</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vector of pointers to the <a class="el" href="class_surface.html" title="A base class for every geometry class (e.g., Sphere, Triangle, Mesh). ">Surface</a> objects that compose this <a class="el" href="class_mesh.html" title="A class to create and manipulate triangular meshes. ">Mesh</a>. </p>

</div>
</div>
<a id="ab0f87ac2cccc51a28e2e296c1e665609"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0f87ac2cccc51a28e2e296c1e665609">&sect;&nbsp;</a></span>verts</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::vector&lt;<a class="el" href="class_surface.html">Surface</a>*&gt; &gt; Mesh::verts</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_mesh_8hpp_source.html">Mesh.hpp</a></li>
<li>src/<a class="el" href="_mesh_8cpp.html">Mesh.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_mesh.html">Mesh</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
